//+------------------------------------------------------------------+
//|                                                          SMA.mq5 |
//|                        Copyright 2009, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
//---- ָ꽫лͼ
#property indicator_chart_window
//---- ָļͻͼʹһ
#property indicator_buffers 1
//---- ֻһͼ 
#property indicator_plots   1
//---- ͼʽΪ
#property indicator_type1   DRAW_LINE
//---- ָߵɫǺɫ 
#property indicator_color1  Red 

//---- ָ
input int MAPeriod = 13; //ƽ
input int MAShift = 0; //ˮƽת ()

//---- ̬
//ָ껺
double ExtLineBuffer[]; 
//+------------------------------------------------------------------+
//| Զָʼ                         |
//+------------------------------------------------------------------+  
void OnInit()
  {
//----+
//---- Ѷ̬ ExtLineBuffer Ϊָĵ0
   SetIndexBuffer(0,ExtLineBuffer,INDICATOR_DATA);
//----  MAShift ˮƽת
   PlotIndexSetInteger(0,PLOT_SHIFT,MAShift);
//----  MAPeriod ûͼ
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,MAPeriod);  
//----+
  }
//+------------------------------------------------------------------+
//| Զָ                              |
//+------------------------------------------------------------------+
int OnCalculate(
                const int rates_total,    // ǰʷпõ
                const int prev_calculated,// ǰһ㷵ص
                const int begin,          // һ
                const double &price[]     // ڼļ۸
                )
  {
//----+   
   //---- ֵǷ㹻ڼ
   if (rates_total < MAPeriod - 1 + begin)
    return(0);
   
   //---- ֲ 
   int first, bar, iii;
   double Sum, SMA;
   
   //---- ѭеʼ
   if(prev_calculated==0) // Ƿָһμ
      first=MAPeriod-1+begin; // 
   else first=prev_calculated-1; // 

   //---- ѭ
   for(bar = first; bar < rates_total; bar++)
    {    
      Sum=0.0;
      //---- ۼƼѭƽ
      for(iii=0;iii<MAPeriod;iii++)
         Sum+=price[bar-iii]; // ͬ: Sum = Sum + price[bar - iii];
         
      //---- ƽֵ
      SMA=Sum/MAPeriod;

      //---- ָ껺ԪֵΪǼSMAֵ
      ExtLineBuffer[bar]=SMA;
    }
//----+     
   return(rates_total);
  }
//+------------------------------------------------------------------+